#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include "3dfx_tvtool.h"
#include "3dfx_tvtool_help.h"

int main(int argc, char *argv[]) {
	GtkWidget *main_window, *about_window;
	GtkWidget *main_box, *sub_box, *items_box;
	GtkWidget *separator;
	GtkWidget *button;
	GtkWidget *label;
	GtkWidget *menu_file, *menu_help, *menu_item, *file_menu, *help_menu, *menu_bar;
		
	char data[DATA_SIZE];
	
	gtk_init(&argc, &argv);

	main_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

		about_window = gtk_dialog_new();
			gtk_window_set_title(GTK_WINDOW(about_window), (gpointer)ABOUT_WINDOW_TITLE);
			gtk_window_set_resizable(GTK_WINDOW(about_window), FALSE);
			gtk_window_set_position(GTK_WINDOW(about_window), GTK_WIN_POS_CENTER);
			gtk_window_set_transient_for(GTK_WINDOW(about_window), GTK_WINDOW (main_window));
			gtk_container_set_border_width(GTK_CONTAINER(about_window), 15);
	
			label = gtk_label_new("3dfx TV-Tool v"VERSION"\nby oliver (oliver@are-b.org)\n");
				gtk_box_pack_start(GTK_BOX(GTK_DIALOG(about_window)->vbox), label, TRUE, TRUE, 0);
			gtk_widget_show(label);	
	
			button = gtk_button_new_with_label(OK);
				gtk_box_pack_start(GTK_BOX(GTK_DIALOG(about_window)->action_area), button, TRUE, TRUE, 0);
				g_signal_connect_swapped(G_OBJECT(button), "clicked", G_CALLBACK(gtk_widget_hide), (gpointer)about_window);
			gtk_widget_show(button);
		gtk_widget_hide(about_window);
	
		gtk_window_set_title(GTK_WINDOW(main_window), (gpointer)"3dfx TV Tool v"VERSION);
		gtk_window_set_resizable(GTK_WINDOW(main_window), FALSE);
		g_signal_connect(G_OBJECT(main_window), "destroy", G_CALLBACK(gtk_main_quit), NULL);
		g_signal_connect(G_OBJECT(main_window), "delete_event", G_CALLBACK(gtk_main_quit), NULL);

		menu_file = gtk_menu_new();
		
			menu_item = gtk_menu_item_new_with_mnemonic(LOAD_MENU);		
				gtk_menu_shell_append(GTK_MENU_SHELL(menu_file), menu_item);
				g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(button_action), (gpointer)"qload");
			gtk_widget_show(menu_item);
				
			menu_item = gtk_menu_item_new_with_mnemonic(SAVE_MENU);		
				gtk_menu_shell_append(GTK_MENU_SHELL(menu_file), menu_item);
				g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(button_action), (gpointer)"qsave");
			gtk_widget_show(menu_item);

			menu_item = gtk_separator_menu_item_new();
				gtk_menu_shell_append(GTK_MENU_SHELL(menu_file), menu_item);
			gtk_widget_show(menu_item);

			menu_item = gtk_menu_item_new_with_mnemonic(QUIT_MENU);
				gtk_menu_shell_append(GTK_MENU_SHELL(menu_file), menu_item);
				g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(gtk_main_quit), NULL);
			gtk_widget_show(menu_item);

			file_menu = gtk_menu_item_new_with_mnemonic(FILE_MENU_TITLE);
   			gtk_widget_show(file_menu);
		
		gtk_menu_item_set_submenu(GTK_MENU_ITEM(file_menu), menu_file);

		menu_help = gtk_menu_new();
		
			menu_item = gtk_menu_item_new_with_mnemonic(ABOUT_MENU);
				gtk_menu_shell_append(GTK_MENU_SHELL(menu_help), menu_item);
				g_signal_connect_swapped(G_OBJECT(menu_item), "activate", G_CALLBACK(gtk_widget_show), (gpointer)about_window);
			gtk_widget_show(menu_item);

			help_menu = gtk_menu_item_new_with_mnemonic(HELP_MENU_TITLE);
			gtk_widget_show(help_menu);

		gtk_menu_item_set_submenu(GTK_MENU_ITEM(help_menu), menu_help);
		
		main_box = gtk_vbox_new(FALSE, 0);
			gtk_container_add(GTK_CONTAINER(main_window), main_box);

			menu_bar = gtk_menu_bar_new();
    				gtk_box_pack_start(GTK_BOX(main_box), menu_bar, FALSE, FALSE, 2);
		    	gtk_widget_show(menu_bar);

			separator = gtk_hseparator_new();
				gtk_box_pack_start(GTK_BOX(main_box), separator, FALSE, TRUE, 0);
			gtk_widget_show(separator);
				
			sub_box = gtk_hbox_new(TRUE, 0);
				gtk_container_add(GTK_CONTAINER(main_box), sub_box);
				
				items_box = gtk_vbox_new(TRUE, 0);
					gtk_container_add(GTK_CONTAINER(sub_box), items_box);
					
					if(!read_tv_out("colorbars", data)) {
						button = gtk_toggle_button_new();
						gtk_box_pack_start(GTK_BOX(items_box), button, TRUE, TRUE, 0);
						if(strchr(data, '1') != 0) {
							gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
							gtk_button_set_label(GTK_BUTTON(button), (gpointer)COLORBARS_BUTTON_ON);
							gtk_button_set_use_underline(GTK_BUTTON(button), TRUE);
						} else {
							gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), FALSE);
							gtk_button_set_label(GTK_BUTTON(button), (gpointer)COLORBARS_BUTTON_OFF);
							gtk_button_set_use_underline(GTK_BUTTON(button), TRUE);
						}
						g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(button_action), (gpointer)"colorbars");
						gtk_widget_show(button);
					}
		
					if(!read_tv_out("tv_off", data)) {
						button = gtk_toggle_button_new();
							gtk_box_pack_start(GTK_BOX(items_box), button, TRUE, TRUE, 0);
							if(strchr(data, '1') != 0) {
								gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), FALSE);
								gtk_button_set_label(GTK_BUTTON(button), (gpointer)TV_OUT_DISABLED);
								gtk_button_set_use_underline(GTK_BUTTON(button), TRUE);
							} else {
								gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
								gtk_button_set_label(GTK_BUTTON(button), (gpointer)TV_OUT_ENABLED);
								gtk_button_set_use_underline(GTK_BUTTON(button), TRUE);
							}
							g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(button_action), (gpointer)"tv_off");
						gtk_widget_show(button);
					}
					
				gtk_widget_show(items_box);
				
				if(!read_tv_out("luma", data)) {
					items_box = gtk_vbox_new(TRUE, 0);
						gtk_container_add(GTK_CONTAINER(sub_box), items_box);
				
						button = gtk_check_button_new_with_label(LUMA_ANTI_PSEUDO_GAMA_REMOVAL);
							gtk_box_pack_start(GTK_BOX(items_box), button, TRUE, TRUE, 0);
							if(atoi(data) >= 128) {
								gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), FALSE);
							} else {
								gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
							}
							g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(button_action), (gpointer)"luma_agama");
						gtk_widget_show(button);
						
						button = gtk_check_button_new_with_label(LUMA_PSEUDO_GAMA_REMOVAL);
							gtk_box_pack_start(GTK_BOX(items_box), button, TRUE, TRUE, 0);
							if((atoi(data) - 128) >= 64) {
								gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), FALSE);
							} else {
								gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
							}
							g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(button_action), (gpointer)"luma_gama");
						gtk_widget_show(button);
					gtk_widget_show(items_box);
				}
				
				if(!read_tv_out("chroma", data)) {
					items_box = gtk_vbox_new(TRUE, 0);
						gtk_container_add(GTK_CONTAINER(sub_box), items_box);
				
						button = gtk_check_button_new_with_label(CHROMA_ANTI_PSEUDO_GAMA_REMOVAL);
							gtk_box_pack_start(GTK_BOX(items_box), button, TRUE, TRUE, 0);
							if(atoi(data) >= 128) {
								gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), FALSE);
							} else {
								gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
							}
							g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(button_action), (gpointer)"chroma_agama");
						gtk_widget_show(button);
						
						button = gtk_check_button_new_with_label(CHROMA_PSEUDO_GAMA_REMOVAL);
							gtk_box_pack_start(GTK_BOX(items_box), button, TRUE, TRUE, 0);
							if((atoi(data) - 128) >= 64) {
								gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), FALSE);
								} else {
								gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
							}
							g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(button_action), (gpointer)"chroma_gama");
						gtk_widget_show(button);
					gtk_widget_show(items_box);
				}
	
			gtk_widget_show(sub_box);
		
			if(!read_tv_out("ntsc", data)) {
				items_box = gtk_vbox_new(TRUE, 0);
					gtk_container_add(GTK_CONTAINER(sub_box), items_box);

						button = gtk_radio_button_new_with_label(NULL, MODE_NTSC);
							gtk_box_pack_start(GTK_BOX(items_box), button, TRUE, TRUE, 0);
							if(strchr(data, '1') != 0) {
								gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
							}
							g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(button_action), (gpointer)"ntsc");
						gtk_widget_show(button);
						button = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button), MODE_PAL);
							gtk_box_pack_start(GTK_BOX(items_box), button, TRUE, TRUE, 0);
							if(strchr(data, '0') != 0) {
								gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
							}
							g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(button_action), (gpointer)"pal");
						gtk_widget_show(button);
				gtk_widget_show(items_box);	
			}
		

			sub_box = gtk_vbox_new(TRUE, 0);
				gtk_container_add(GTK_CONTAINER(main_box), sub_box);

				separator = gtk_hseparator_new();
					gtk_box_pack_start(GTK_BOX(sub_box), separator, FALSE, TRUE, 0);
				gtk_widget_show(separator);
				
				items_box = gtk_hbox_new(TRUE, 0);
					gtk_container_add(GTK_CONTAINER(sub_box), items_box);
					
					if(!read_tv_out("status", data)) {
						button = gtk_button_new_with_mnemonic(REAPPLY);
							gtk_box_pack_end(GTK_BOX(items_box), button, TRUE, FALSE, 0);
							g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(button_action), (gpointer)"status");
						gtk_widget_show(button);
					}
					
					button = gtk_button_new_with_label(QUIT);
						gtk_box_pack_end(GTK_BOX(items_box), button, TRUE, TRUE, 0);
						g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(gtk_main_quit), NULL);
				//	gtk_widget_show(button);

				gtk_widget_show(items_box);
			gtk_widget_show(sub_box);
		gtk_widget_show(main_box);	
		gtk_menu_shell_append(GTK_MENU_SHELL(menu_bar), file_menu);
		gtk_menu_item_right_justify(GTK_MENU_ITEM(help_menu));
		gtk_menu_shell_append(GTK_MENU_SHELL(menu_bar), help_menu);
	gtk_widget_show(main_window);

	gtk_main();
        return 0;
}

int write_tv_out(char *control, char *data) {
        FILE *control_file;
	char temp_str[48] = PATH;
	if((strlen(control) + strlen(PATH)) < 48) {
		strcat(temp_str, control);
	        if((control_file = fopen(temp_str, "w")) != NULL) {
			fprintf(control_file, "%s", data);
        		fclose(control_file);
#ifdef DEBUG
			g_print(WRITE_TV_OUT_WRITTEN, data, control);
#endif
        	} else {
                	fprintf(stderr,WRITE_TV_OUT_COULD_NOT_WRITE, data, control);
			return 1;
        	}
	}  else {
		fputs(OVERFLOW_ERROR, stderr);
	}
        return 0;
}

int read_tv_out(char *control, char *data) {
	FILE *control_file;
	char temp_str[48] = PATH;
	if((strlen(control) + strlen(PATH)) < 48) {
		strcat(temp_str, control);
		if((control_file = fopen(temp_str, "r")) != NULL) {
			fgets(data, DATA_SIZE, control_file);
		} else {
			fprintf(stderr,ERROR_READING_FILE, control_file);
			return 1;
		}
		return 0;
	} else {
		fputs(OVERFLOW_ERROR, stderr);
	}
}

int load_settings(char *filename) {
	FILE *load_file;
	char data[128];
	if((load_file = fopen(filename, "r")) != NULL) {
		fgets(data,sizeof(data), load_file);
		if(!strcmp(data ,"v"VERSION)) {
			fputs(LOAD_SETTINGS_WRONG_VERSION, stderr);
		} else {
			for(; fgets(data, sizeof(data), load_file) != NULL;) {
				loading_processor(data, "chroma");
				loading_processor(data, "colorbars");	
				loading_processor(data, "depth");
				loading_processor(data, "half");
				loading_processor(data, "interlace");
				loading_processor(data, "luma");
				loading_processor(data, "ntsc");	
				loading_processor(data, "res");
				loading_processor(data, "tv_off");
			}
		}
		fclose(load_file);
	} else {
		fprintf(stderr,ERROR_READING_FILE, filename);
		return 1;
	}
	return 0;
}

int loading_processor(char *data, char *value) {
	char *tmp_ptr;
	if(data[0] != '#') {
		if(strcasestr(data, value) != 0) {
			for(;strpbrk(data, " \t=") != 0; strcpy(data, data + 1));
			if(tmp_ptr = strchr(data, '\n')) {
				*tmp_ptr = '\0';
			}
			write_tv_out(value, data);
		}
	}
	return 0;
}

int save_settings(char *filename) {
	FILE *save_file;
	char data[DATA_SIZE];
	if((save_file = fopen(filename,"w")) != NULL) {
		fprintf(save_file,SAVEFILE_HEADER, VERSION);
		read_tv_out("chroma", data);
		fprintf(save_file,"Chroma\t\t= %s", data);
		read_tv_out("colorbars", data);
		fprintf(save_file,"Colorbars\t= %s", data);
		read_tv_out("depth", data);
		fprintf(save_file,"Depth\t\t= %s", data);
		read_tv_out("interlace", data);
		fprintf(save_file,"Interlace\t= %s", data);
		read_tv_out("luma", data);
		fprintf(save_file,"Luma\t\t= %s", data);
		read_tv_out("ntsc", data);
		fprintf(save_file,"NTSC\t\t= %s", data);
		read_tv_out("svideo", data);
		fprintf(save_file,"SVideo\t\t= %s", data);
		read_tv_out("res", data);
		fprintf(save_file,"Res\t\t= %s", data);
		read_tv_out("half", data);
		fprintf(save_file,"Half\t\t= %s", data);
		read_tv_out("tv_off", data);
		fprintf(save_file,"TV_Off\t\t= %s", data);
		fclose(save_file);
	} else {
		fprintf(stderr,ERROR_WRITING_FILE, filename);
		return 1;
	}
	return 0;
}

int button_action(GtkWidget *button, gpointer data) {
	char data_buffer[DATA_SIZE], total[DATA_SIZE];
	if(data == "colorbars") {	
		if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button))) {
			gtk_button_set_label(GTK_BUTTON(button), (gpointer)COLORBARS_BUTTON_ON);
			gtk_button_set_use_underline(GTK_BUTTON(button), TRUE);
			write_tv_out("colorbars", "1");
    		} else {
			gtk_button_set_label(GTK_BUTTON(button), (gpointer)COLORBARS_BUTTON_OFF);
			write_tv_out("colorbars", "0");
		}
	}
	if(data == "tv_off") {
		if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button))) {
			gtk_button_set_label(GTK_BUTTON(button), (gpointer)TV_OUT_ENABLED);
			write_tv_out("tv_off", "0");
		} else { 
			gtk_button_set_label(GTK_BUTTON(button), (gpointer)TV_OUT_DISABLED);
			write_tv_out("tv_off", "1");
		}
	}
	if(data == "luma_agama") {
		if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button))) {
			read_tv_out("luma", data_buffer);
			sprintf(total, "%d", atoi(data_buffer) - 128);
			write_tv_out("luma", total);
		} else {
			read_tv_out("luma", data_buffer);
			sprintf(total, "%d", atoi(data_buffer) + 128);
			write_tv_out("luma", total);
		}
	}
	if(data == "luma_gama") {
		if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button))) {
			read_tv_out("luma", data_buffer);
			sprintf(total, "%d", atoi(data_buffer) - 64);
			fprintf(stderr, "active lg  toatal %s\n", total);
			write_tv_out("luma", total);
		} else {
			read_tv_out("luma", data_buffer);
			sprintf(total, "%d", atoi(data_buffer) + 64);
			fprintf(stderr, "inactive lg total %s\n", total);
			write_tv_out("luma", total);
		}
	}
	if(data == "chroma_agama") {
		if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button))) {
			read_tv_out("chroma", data_buffer);
			sprintf(total, "%d", atoi(data_buffer) - 128);
			write_tv_out("chroma", total);
		} else {
			read_tv_out("chroma", data_buffer);
			sprintf(total, "%d", atoi(data_buffer) + 128);
			write_tv_out("chroma", total);
		}
	}
	if(data == "chroma_gama") {
		if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button))) {
			read_tv_out("chroma", data_buffer);
			sprintf(total, "%d", atoi(data_buffer) - 64);
			fprintf(stderr, "active lg  toatal %s\n", total);
			write_tv_out("chroma", total);
		} else {
			read_tv_out("chroma", data_buffer);
			sprintf(total, "%d", atoi(data_buffer) + 64);
			fprintf(stderr, "inactive lg total %s\n", total);
			write_tv_out("chroma", total);
		}
	}
	if(data == "ntsc") {
		if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button))) {
			write_tv_out("ntsc", "1");
		}
	}
	if(data == "pal") {
		if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button))) {
			write_tv_out("ntsc", "0");
		}
	}
	if(data == "status") {
		read_tv_out("status", data_buffer);
	}
	if(data == "qsave") {
		save_settings(DEFAULT_SAVE_FILE);
	}
	if(data == "qload") {
		load_settings(DEFAULT_SAVE_FILE);
	}
}
